SendMode, Input

; Parse the command-line arguments sent by FARR
RegExMatch( DllCall( "GetCommandLineA", "Str" ), "FarrFolders\.exe.*?(?P<window_id>\d+) ""(?P<path>.*)""", f_) 

; Remove trailing slash
If (substr(f_path, 0) = "\")
	StringTrimRight, f_path, f_path, 1

; Read settings
IniRead, f_filemanager, FarrFolders.ini, CustomFileManager, path
f_filemanager := f_filemanager ? f_filemanager : "explorer.exe"
IniRead, f_usequotes, FarrFolders.ini, Settings, usequotes, 0

; Explorer, 7-Zip, WinRAR, FileZilla, ACDSee Classic, XnView, xplorer^2
f_Edit1Apps = ExploreWClass,CabinetWClass,FM,WinRarWindow,FileZilla Main Window,ACDBrowser,XmainClass,ATL:ExplorerFrame

; Get class information about the last active window
WinGetClass, f_class, ahk_id %f_window_id%

; Dialog or an app that has an Edit1 control
if f_class in #32770,%f_Edit1Apps%
{
    ControlGetPos, f_Edit1Pos,,,, Edit1, ahk_id %f_window_id%
    ControlGetPos, f_TBW32Pos,,,, ToolbarWindow322, ahk_id %f_window_id%
}

; Open path in last window if it's a window where we can, else open in the file manager of choice
if f_class = #32770    ; It's a dialog.
{
	if f_Edit1Pos <>   ; And it has an Edit1 control.
	{
		; Activate the window so that if the user is middle-clicking
		; outside the dialog, subsequent clicks will also work:
		WinActivate ahk_id %f_window_id%
		; Retrieve any filename that might already be in the field so
		; that it can be restored after the switch to the new folder:
		ControlGetText, f_text, Edit1, ahk_id %f_window_id%
		ControlSetText, Edit1, %f_path%, ahk_id %f_window_id%
		ControlSend, Edit1, {Enter}, ahk_id %f_window_id%
		Sleep, 100  ; It needs extra time on some dialogs or in some cases.
		ControlSetText, Edit1, %f_text%, ahk_id %f_window_id%
		return
	}
	; else fall through to the bottom of the subroutine to take standard action.
}
else if f_class in %f_Edit1Apps%
{
	if f_Edit1Pos <>   ; And it has an Edit1 control.
	{
		ControlSetText, Edit1, %f_path%, ahk_id %f_window_id%
		; Tekl reported the following: "If I want to change to Folder L:\folder
		; then the addressbar shows http://www.L:\folder.com. To solve this,
		; I added a {right} before {Enter}":
		ControlSend, Edit1, {Right}{Enter}, ahk_id %f_window_id%
		return
	}
	; Vista/7 explorer (with the address toolbar)
	if f_TBW32Pos <>
	{
		ControlClick, ToolbarWindow322, ahk_id %f_window_id%, , , , X4
		ControlSetText, Edit1, %f_path%, ahk_id %f_window_id%
		; Tekl reported the following: "If I want to change to Folder L:\folder
		; then the addressbar shows http://www.L:\folder.com. To solve this,
		; I added a {right} before {Enter}":
		ControlSend, Edit1, {Right}{Enter}, ahk_id %f_window_id%
		return	
	}
	; else fall through to the bottom of the subroutine to take standard action.
}
; Directory Opus
else if f_class in dopus.lister
{
	ControlSetText, Edit2, %f_path%, ahk_id %f_window_id%
	ControlSend, Edit2, {Right}{Enter}, ahk_id %f_window_id%
	return
}
; FileZilla 3
else if f_Class in wxWindowClassNR
{
	ControlClick, Edit5, ahk_id %f_window_id%
	ControlSetText, Edit5, %f_path%, ahk_id %f_window_id%
	ControlSend, Edit5, {Right}{Enter}, ahk_id %f_window_id%
	ControlFocus, SysListView321, ahk_id %f_window_id% ; Set focus to file list
	return
}
; Total Commander (thanks to FatZgrED :p)
else if f_Class in TTOTAL_CMD
{
	ControlClick, Edit1, ahk_id %f_window_id%
	;Total Commander has Edit1 control but you need to cd to location
	ControlSetText, Edit1, cd %f_path%, ahk_id %f_window_id%
	ControlSend, Edit1, {Right}{Enter}, ahk_id %f_window_id%
	return
}
; Microsoft Office application
else if f_Class contains bosa_sdm_
{
	WinActivate ahk_id %f_window_id%
	ControlGetText, f_Edit1Text, RichEdit20W2, ahk_id %f_window_id%
	ControlClick, RichEdit20W2, ahk_id %f_window_id%	;<----------important!!!
	ControlSetText, RichEdit20W2, %f_path%, ahk_id %f_window_id%
	ControlSend, RichEdit20W2, {Enter}, ahk_id %f_window_id%
	Sleep, 100
	ControlSetText, RichEdit20W2, %f_Edit1Text%, ahk_id %f_window_id%
	return
}
; Console windows
else if f_Class = ConsoleWindowClass
{
	WinActivate, ahk_id %f_window_id%
	StringLeft, f_drive, f_path, 1
	Send, cd\{Enter}
	Send, %f_drive%:{Enter}
	Send, cd %f_path%{Enter}
	return
}
; Screw it, just open the path in our file manager of choice
else
{
	_f_path := f_usequotes ? """" f_path """" : f_path	
	Run, %f_filemanager% %_f_path%  ; Might work on more systems without double quotes.
}