#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#NoTrayIcon
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

#Include LV.ahk
#Include Point.ahk
#Include Rectangle.ahk

FARRstuff := " | %ALIASDIR%\FarrFolders.exe %LASTHWND% "

Gosub, CreateMainGUI
Gosub, CreateContextMenu
Gosub, LoadInfo

return

CreateMainGui:
	Gui, Margin, 10, 10
	Gui, +toolwindow
	Gui, Font, w600
	Gui, Add, GroupBox, w420 h230, My Favorite Folders
	Gui, Font
	Gui, Add, Text, x20 y30 h20, --- Right-click to add/edit/delete. Drag and drop to reorder. ---
	Gui, Add, ListView, x20 y50 w400 h180 +NoSortHdr -Multi +Grid gFolderListView vFolderListView, #|Display name|Folder path
	Gui, Font, w600
	Gui, Add, GroupBox, x10 y250 w420 h70, My File Manager
	Gui, Font
	Gui, Add, Text, x20 y270 h20, --- Path to your custom file manager [leave blank to use explorer.exe] ---
	Gui, Add, Edit, x20 y290 w350 vcustomfilemanager
	Gui, Add, Button, x380 y290 h20 gSelectCustomFileManager, ...
	Gui, Font, w600
	Gui, Add, GroupBox, x10 y330 w420 h50, Other Settings
	Gui, Font
	Gui, Add, CheckBox, x20 y350 h20 vusequotes, Use quotes - check this if your file manager hates spaces in paths
	Gui, Add, Button, x10 y390 w205 h30 gCancel, Cancel
	Gui, Add, Button, x225 y390 w205 h30 gSaveAndClose Default, Save and Close
	Gui, Show, , FarrFolders Settings
Return

GuiContextMenu:
	If A_GuiControl <> FolderListView
		return
	item := A_EventInfo
	Menu, ContextMenu, Show, %A_GuiX%, %A_GuiY%
return

Cancel:
GuiEscape:
GuiClose:
ExitApp

SaveAndClose:
	Gui, 1: Default
	Gui, 1: Submit, NoHide
	Loop, % cnt := LV_GetCount()
		LV_GetText(name%A_Index%, A_Index, 2), LV_GetText(path%A_Index%, A_Index, 3)
	Loop, % cnt
		FarrFoldersTxt .= name%A_Index% . FARRstuff . """" . path%A_Index% . """" . "`n"
	StringTrimRight, FarrFoldersTxt, FarrFoldersTxt, 1
	FileDelete, FarrFolders.txt
	FileAppend, %FarrFoldersTxt%, FarrFolders.txt
	IniWrite, %customfilemanager%, FarrFolders.ini, CustomFileManager, path
	IniWrite, %usequotes%, FarrFolders.ini, Settings, usequotes
ExitApp


SelectCustomFileManager:
	Gui, +owndialogs
	FileSelectFile, file, 3, %ProgramFiles% , Choose path to your custom file manager, Executable (*.exe)
	If file
		GuiControl, , customfilemanager, %file%
return

CreateContextMenu:
	Menu, ContextMenu, Add, &Edit, ContextMenuEdit
	Menu, ContextMenu, Add, &Delete, ContextMenuDelete
	Menu, ContextMenu, Add
	Menu, ContextMenu, Add, &Add New Folder, ContextMenuAdd
return

ContextMenuEdit:
	If not item
		return
	edit := 1
	name := path := ""
	LV_GetText(name, item, 2), LV_GetText(path, item, 3)
	Gosub, CreateFolderEditorGUI
	GuiControl, 2: , displayname, %name%
	GuiControl, 2: , folderpath, %path%
return

ContextMenuAdd:
	edit := 0
	Gosub, CreateFolderEditorGUI
return

CreateFolderEditorGUI:
	Gui, 1: +Disabled
	Gui, 2: +owner +toolwindow
	Gui, 2: Add, Text, x10 y13 , Display Name:
	Gui, 2: Add, Edit, x90 y10 h20 w250 vdisplayname,
	Gui, 2: Add, Text, x10 y43 , Folder Path:
	Gui, 2: Add, Edit, x90 y40 w250 h20 vfolderpath,
	Gui, 2: Add, Button, x350 y40 h20 gSelectFolder, ...
	Gui, 2: Add, Button, x130 y70 w100 h30 g2Cancel, Cancel
	Gui, 2: Add, Button, x240 y70 w100 h30 g2SaveAndClose Default, Save and Close
	Gui, 2: Show, , Folder Information
return

2Cancel:
2GuiEscape:
2GuiClose:
	Gui, 1: -Disabled
	Gui, 2: Destroy
return

SelectFolder:
	Gui, 2: +owndialogs
	FileSelectFolder, folder, , 3, Choose a Favorite Folder
	If folder
		GuiControl, 2: , folderpath, %folder%
return

2SaveAndClose:
	Gui, 2: Submit, NoHide
	Gui, 1: -Disabled
	Gui, 2: Destroy
	Gui, 1: Default
	Gui, 1: Show
	If edit
	{
		LV_Modify(item, "Select Focus", item, displayname, folderpath)
		return
	}
	Else
		LV_Add("Select Focus", LV_GetCount() + 1, displayname, folderpath)
return


ContextMenuDelete:
	If not item
		return
	LV_Delete(item)
	Loop, % LV_GetCount()
		LV_Modify(A_Index, "", A_Index)
	LV_Modify( (item <= LV_GetCount()) ? item : item - 1,  "Select Focus")
return


LoadInfo:
	FileRead, folderlist, FarrFolders.txt
	StringReplace, folderlist, folderlist, %FARRstuff% , |, All
	
	GuiControl, -Redraw, FolderListView
	Loop, parse, folderlist, `n, `r
	{
		StringSplit, x, A_LoopField , |
		StringReplace, x2, x2, ", , All
		LV_Add("", A_Index, x1, x2)
	}
	GuiControl, +Redraw, FolderListView
	LV_ModifyCol(1), LV_ModifyCol(2)

	IniRead, customfilemanager, FarrFolders.ini, CustomFileManager, path, %A_Space%
	GuiControl, , customfilemanager, %customfilemanager%
	IniRead, usequotes, FarrFolders.ini, Settings, usequotes, 0
	GuiControl, , usequotes, %usequotes%
return

FolderListView:
    ;Only part the user touches
    if (A_GuiEvent = "D")
    {
        ;gives the Gui control keyboard focus when a drag begins (optional)
        ;GuiControl, Focus, %A_GuiControl%
        
        if (DropLocation := LV_DragDrop())
        {
            ;InsertAfter is a boolean (either true or false)
            ;Position is the one-based insertion point
            LV_ParseDDResults(DropLocation, InsertAfter, Position)

			NewPosition := InsertAfter ? Position + 1 : Position
			LV_GetText(name, A_EventInfo, 2), LV_GetText(path, A_EventInfo, 3)
			LV_Insert(NewPosition, "", "", name, path)
			LV_Delete( A_EventInfo < NewPosition ? A_EventInfo : A_EventInfo + 1)
			Loop, % LV_GetCount()
				LV_Modify(A_Index, "", A_Index)
			LV_Modify( A_EventInfo < NewPosition ? NewPosition - 1 : NewPosition, "Select Focus")
        }
    }
return