; Thanks to animeanime of the AHK forums for these functions for working with RECT structures
; http://www.autohotkey.com/forum/viewtopic.php?t=40850

;==============================;
;   RECT STRUCTURE FUNCTIONS   ;
;==============================;

Rectangle_create(ByRef Rectangle, Left = 0, Top = 0, Right = 0, Bottom = 0)
{
    VarSetCapacity(Rectangle, 16)
        , Rectangle_setTopLeft(Rectangle, Left, Top)
        , Rectangle_setBottomRight(Rectangle, Right, Bottom)
}

Rectangle_getPoints(ByRef Rectangle, ByRef Left, ByRef Top, ByRef Right, ByRef Bottom)
{
    Left := Rectangle_getLeft(Rectangle)
    Top := Rectangle_getTop(Rectangle)
    Right := Rectangle_getRight(Rectangle)
    Bottom := Rectangle_getBottom(Rectangle)
}

Rectangle_setPoints(ByRef Rectangle, Left, Top, Right, Bottom)
{
    Rectangle_setLeft(Rectangle, Left)
    Rectangle_setTop(Rectangle, Top)
    Rectangle_setRight(Rectangle, Right)
    Rectangle_setBottom(Rectangle, Bottom)
}

Rectangle_getTopLeft(ByRef Rectangle, ByRef Left, ByRef Top)
{
    Left := Rectangle_getLeft(Rectangle)
    Top := Rectangle_getTop(Rectangle)
}

Rectangle_setTopLeft(ByRef Rectangle, Left, Top)
{
    Rectangle_setLeft(Rectangle, Left)
    Rectangle_setTop(Rectangle, Top)
}

Rectangle_getTopLeftPoint(ByRef Rectangle, ByRef TopLeft)
{
    Left := Rectangle_getLeft(Rectangle)
    Top := Rectangle_getTop(Rectangle)
    
    Point_create(TopLeft, Left, Top)
}

Rectangle_setTopLeftPoint(ByRef Rectangle, ByRef TopLeft)
{
    Rectangle_setLeft(Rectangle, Point_getX(TopLeft))
    Rectangle_setTop(Rectangle, Point_getY(TopLeft))
}

Rectangle_getBottomRight(ByRef Rectangle, ByRef Right, ByRef Bottom)
{
    Right := Rectangle_getRight(Rectangle)
    Bottom := Rectangle_getBottom(Rectangle)
}

Rectangle_setBottomRight(ByRef Rectangle, Right, Bottom)
{
    Rectangle_setRight(Rectangle, Right)
    Rectangle_setBottom(Rectangle, Bottom)
}

Rectangle_getBottomRightPoint(ByRef Rectangle, ByRef BottomRight)
{
    Right := Rectangle_getRight(Rectangle)
    Bottom := Rectangle_getBottom(Rectangle)
    
    Point_create(BottomRight, Right, Bottom)
}

Rectangle_setBottomRightPoint(ByRef Rectangle, ByRef BottomRight)
{
    Rectangle_setRight(Rectangle, Point_getX(BottomRightt))
    Rectangle_setBottom(Rectangle, Point_getY(BottomRight))
}

Rectangle_getLeft(ByRef Rectangle)
{
    return NumGet(Rectangle, 0, "int")
}

Rectangle_setLeft(ByRef Rectangle, Left)
{
    NumPut(Left, Rectangle, 0, "int")
}

Rectangle_getTop(ByRef Rectangle)
{
    return NumGet(Rectangle, 4, "int")
}

Rectangle_setTop(ByRef Rectangle, Top)
{
    NumPut(Top, Rectangle, 4, "int")
}

Rectangle_getRight(ByRef Rectangle)
{
    return NumGet(Rectangle, 8, "int")
}

Rectangle_setRight(ByRef Rectangle, Right)
{
    NumPut(Right, Rectangle, 8, "int")
}

Rectangle_getBottom(ByRef Rectangle)
{
    return NumGet(Rectangle, 12, "int")
}

Rectangle_setBottom(ByRef Rectangle, Bottom)
{
    NumPut(Bottom, Rectangle, 12, "int")
}